#!/usr/bin/env perl

 
# extensions.conf lines
#[nagios-out]
#exten => s,1,AGI(nagiosalert.pl,${Params})
 
use strict;
use warnings;
use Nagios::Cmd;
use Asterisk::AGI;
 
# Don't buffer output
$|=1;
 
#my %input = $AGI->ReadParse();
 
my ($hostname, $service, $username, $message) = split /\|/, $ARGV[0];
$message =~ s/\+/,/g;
 
#$message =~ s/'(.+)'/$1/;
 
my $NAGSOCKET = '/var/lib/nagios3/rw/nagios.cmd';
my $TIME = time();
my ($digit, $t, $repeat);
 
my $AGI = new Asterisk::AGI;
 
if (not -w $NAGSOCKET) { $AGI->verbose ("Unable to open $NAGSOCKET for writing. User: $>  Group $)\n", 1); }
 
my $nagios = Nagios::Cmd->new( $NAGSOCKET );
 
# Prepare the tts audio file
$t = lite -t "$message" -voice rms -o /tmp/$username.wav;
$t = ox /tmp/$username.wav -t raw /tmp/$username.sln16;
$t = hown asterisk.asterisk /tmp/$username.sln16;
$t = p /tmp/$username.sln16 /var/lib/asterisk/sounds/en/;
 
$AGI->answer();
$AGI->exec('WAIT', '1');
$AGI->exec('playback', 'followingisanalert');
 
# Playback the tts error message
ERRMSG: processDigit($AGI->get_data("$username", '200', '1'));
 
$repeat = 2;
while ($repeat > 0)
{
    processDigit($AGI->get_data('1torepeat7toclear', '5000', '1'));
    $repeat--;
}
 
if (not $digit) { $AGI->exec('playback', 'vm-goodbye'); exit 0; }
 
sub processDigit
{
    my ($digit) = @_;
 
    #$AGI->verbose("Digit:$digit");
 
    if (not $digit) { return; }
 
    if ($digit == 1) { goto ERRMSG; }
 
    if ($digit == 7)
    {
        $nagios->service_check($hostname, $service, 1, 'Alert Cleared Via Phone');
 
        $AGI->exec('playback', 'alert_ack');
        exit 0;
    }
}
